/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   purpose : To search for the presence/absence
             of a given key, in a given tempalet vector of items,
             by Linear or Binary Search Algorithm,
             based on a interactive decision.

   linear_binary_search_37.cpp
*/


#include <cctype>

#include "linear_search.h"
#include "binary_search.h"
#include "linear_binary_search.h"

int main(int argc, char* argv[]) {

  vector<int> given_vector = get_vector_item<int>();

  int key = get_item<int>();

  bool found;

  char search_decision = get_char();

  switch(toupper(search_decision)) {
    case 'L' : found = linear_search(key,
                                     given_vector);
               break;
    case 'B' : quicksort_asc(given_vector);

               found = binary_search(key,
                                     given_vector);
               break;
    default  : cerr << "Error: search_decision should be L|B!" << endl;
               exit(1);
  }

  put_found_item(found,
                 key);

}
