/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   search_int.cpp
*/


#include <iostream>
#include <fstream>

using namespace std;

#include "search_int.h"

bool
search_int::
linear_search_int(int key,
                  int v[], 
                  int n) {
  found = false;
  for(int i=0; i<n&&!found; i++)
    if(key==v[i]) found=true;

  return found;
}

bool
search_int::
binary_search_int(int key,
                  int v[],
                  int n) {
  int low = 0;
  int high = n-1;
  int mid;

  found = false;
  while(low<=high&&!found) {
    mid=low+(high-low)/2;
    if(key==v[mid])
      found=true;
    else if(key<v[mid])
      high=mid-1;
    else
      low=mid+1;
  }

  return found;
}

int
search_int::
get_int() {
  cout << "Enter the key value in integer: ";
  cin >> key;
  cout << endl;

  return key;
}

char
search_int::
get_char(char* s) {
  char value;

  cout << s;
  cout << " : ";
  cin >> value;

  cout << endl;

  return value;
}

const int MAX_SIZE_STRING=32;

int
search_int::
get_list_int(int v[]) {
  char filename[MAX_SIZE_STRING];
  int i;

  cout << "--> input filename : ";
  cin >> filename;
  cout << endl;

  ifstream f_in(filename);

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }
  else {
    i = 0;
    while(f_in>>v[i])
      ++i;
  }

  f_in.close();

  return i;
}

void
search_int::
put_int(bool found,
        int key) {
  char filename[MAX_SIZE_STRING];

  cout << "--> output filename : ";
  cin >> filename;
  cout << endl;

  ofstream f_out(filename);

  if(found)
    f_out << "key " << key << " was present in the given_list." << endl;
  else
    f_out << "key " << key << " was not present in the given_list." << endl;

  f_out.close();
}
