/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   search_string.cpp
*/


#include <iostream>
#include <fstream>

#include <string>

using namespace std;

#include "search_string.h"

bool
search_string::
linear_search_string(string key,
                     string v[], 
                     int n) {
  found = false;
  for(int i=0; i<n&&!found; i++)
    if(key==v[i]) found=true;

  return found;
}

bool
search_string::
binary_search_string(string key,
                     string v[],
                     int n) {
  int low = 0;
  int high = n-1;
  int mid;

  found = false;
  while(low<=high&&!found) {
    mid=low+(high-low)/2;
    if(key==v[mid])
      found=true;
    else if(key<v[mid])
      high=mid-1;
    else
      low=mid+1;
  }

  return found;
}

string
search_string::
get_string() {
  cout << "Enter the key value string : ";
  cin >> key;
  cout << endl;

  return key;
}

char
search_string::
get_char(char* s) {
  char value;

  cout << s;
  cout << " : ";
  cin >> value;

  cout << endl;

  return value;
}

const int MAX_SIZE_STRING=32;

int
search_string::
get_list_string(string v[]) {
  char filename[MAX_SIZE_STRING];
  int i;

  cout << "--> input filename : ";
  cin >> filename;
  cout << endl;

  ifstream f_in(filename);

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }
  else {
    i = 0;
    while(f_in>>v[i])
      ++i;
  }

  f_in.close();

  return i;
}

void
search_string::
put_string(bool found,
           string key) {
  char filename[MAX_SIZE_STRING];

  cout << "--> output filename : ";
  cin >> filename;
  cout << endl;

  ofstream f_out(filename);

  if(found)
    f_out << "key " << key << " was present in the given_list." << endl;
  else
    f_out << "key " << key << " was not present in the given_list." << endl;

  f_out.close();
}
