/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   search_int.cpp
*/


#include <iostream>
#include <fstream>

using namespace std;

#include "search_item.h"

template <class T>
bool
search_item<T>::
linear_search_item(T key,
                   vector<T>& v) { 
  found = false;

  int n = v.size();
  for(int i=0; i<n&&!found; i++)
    if(key==v.at(i)) found=true;

  return found;
}

template <class T>
bool
search_item<T>::
binary_search_item(T key,
                   vector<T>& v) { 
  int low = 0;
  int high = v.size()-1;
  int mid;

  found = false;
  while(low<=high&&!found) {
    mid=low+(high-low)/2;
    if(key==v.at(mid))
      found=true;
    else if(key<v.at(mid))
      high=mid-1;
    else
      low=mid+1;
  }

  return found;
}

template <class T>
T
search_item<T>::
get_item() {
  cout << "Enter the key value in item type : ";
  cin >> key;
  cout << endl;

  return key;
}

template <class T>
char
search_item<T>::
get_char(string s) {
  char value;

  cout << s;
  cout << " : ";
  cin >> value;

  cout << endl;

  return value;
}

template <class T>
vector<T>
search_item<T>::
get_vector_item() {
  vector<T> list;

  string filename;

  cout << "--> input filename : ";
  cin >> filename;
  cout << endl;

  ifstream f_in(filename.c_str());

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }
  else {
    int v;
    while(f_in>>v)
      list.push_back(v);
  }

  f_in.close();

  return list;
}

template <class T>
void
search_item<T>::
put_item(bool found,
         T key) {
  string filename;

  cout << "--> output filename : ";
  cin >> filename;
  cout << endl;

  ofstream f_out(filename.c_str());

  if(found)
    f_out << "key " << key << " was present in the given_list." << endl;
  else
    f_out << "key " << key << " was not present in the given_list." << endl;

  f_out.close();
}
