/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   quicksort_asc_string.cpp
*/


#include "common.h"

int partition(vector<string>&, int, int);
void quicksort(vector<string>&, int, int);

void quicksort_asc_string(vector<string>& list) {
  int n = list.size();
  quicksort(list,
            0,
            n-1);
}

int partition(vector<string>& list,
              int i,
              int j) {
  int middle=(i+j)/2;            /* middle as the pivot       */

  string pivot=list[middle];
  list[middle]=list[i];
  list[i]=pivot;

  int p=i;

  for(int k=i+1; k<=j; ++k)
    if(list[k]<pivot) {          /* elements less than pivot  */
      string temp=list[++p];     /* replaced by list[++p]     */
      list[p]=list[k];
      list[k]=temp;
    }

  string temp=list[i];           /* pivot in list[p]          */
  list[i]=list[p];
  list[p]=temp;

  return p;                      /* return pivot position     */
}

void quicksort(vector<string>& list,
               int i,
               int n) {
  int p;

  if(i<n) {
    p=partition(list,            /* p is the list pivot position */
                i,
                n);
    quicksort(list,
              i,
              p-1);
    quicksort(list,
              p+1,
              n);
  }
}
