/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2002.
   author : Salih Yurttas.

   quicksort_asc.cpp
*/


#include <vector>

using namespace std;

template <class T>
int partition(vector<T>& list,
              int i,
              int j) {

  int middle=(i+j)/2;            /* middle as the pivot       */

  T pivot=list[middle];
  list[middle]=list[i];
  list[i]=pivot;

  int p=i;

  for(int k=i+1; k<=j; k++)
    if(list[k]<pivot) {          /* elements less than pivot  */
      T temp=list[++p];          /* replaced by list[++p]     */
      list[p]=list[k];
      list[k]=temp;
    }

  T temp=list[i];                /* pivot in list[p]          */
  list[i]=list[p];
  list[p]=temp;

  return p;                      /* return pivot position     */
}


template <class T>
void quicksort(vector<T>& list,
               int i,
               int n) {
  int p;

  if(i<n) {
    p=partition(list,            /* p is the list pivot position */
                i,
                n);
    quicksort(list,
              i,
              p-1);
    quicksort(list,
              p+1,
              n);
  }
}

template <class T>
void quicksort_asc(vector<T>& list) {
  int n = list.size();

  quicksort(list,
            0,
            n-1);
}
