/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   quicksort_asc_chars.cpp
*/


#include <cstring>

const int MAX_SIZE_STRING=32;

int partition(char*[], int, int);
void quicksort(char*[], int, int);

void quicksort_asc_chars(char* list[],
                         int n) {
  quicksort(list,
            0,
            n-1);
}

int partition(char* list[],
              int i,
              int j) {

  int middle = (i+j)/2;          // middle as the pivot

  char* pivot = new char[MAX_SIZE_STRING];

  strcpy(pivot,list[middle]);
  strcpy(list[middle],list[i]);
  strcpy(list[i],pivot);

  int p = i;

  char* temp = new char[MAX_SIZE_STRING];

  for(int k=i+1; k<=j; k++)
    if(strcmp(list[k],pivot)<0) { // elements less than pivot
      strcpy(temp,list[++p]);     // replaced by list[++p]
      strcpy(list[p],list[k]);
      strcpy(list[k],temp);
    }

  strcpy(temp,list[i]);           // pivot in list[p]
  strcpy(list[i],list[p]);
  strcpy(list[p],temp);

  return p;                       // return pivot position
}

void quicksort(char* list[],
               int i,
               int n) {
  int p;

  if(i<n) {
    p = partition(list,          // p is the list pivot position
                  i,
                  n);
    quicksort(list,
              i,
              p-1);
    quicksort(list,
              p+1,
              n);
  }
}
