/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   purpose : To search and/or sort a given list of integers
             by interactive choice of L|B for search
             using LinearSearch Algorithm
                or BinarySearch Algorithm or
             by interactive choice of B|I|Q|S for sort
             using BubbleSort Algorithm
                or InsertionSort Algorithm
                or QuickSort Algorithm
                or SelectionSort Algorithm.

   search_sort_int_00.cpp
*/


#include "search_sort_int.h"

int main(int argc, char* argv[]) {

  char repeat_decision;

  do {
    vector<int> given_list;

    get_list_int(given_list);

    char s_s_decision = get_char("Search|Sort");

    switch((SO)(toupper(s_s_decision))) {
      case Search : {
        int key;
        bool found;

        key = get_int();

        s_s_decision = get_char("Linear|Binary");

        switch(toupper(s_s_decision)) {
          case Linear : found = linear_search_int(key,
                                                  given_list);
                        break;
          case Binary : found = binary_search_int(key,
                                                  given_list);
                        break;
          default : cerr << "Error: sort_decision should be L|B" << endl;
                    exit(1);
        }

        put_found_int(found,
                      key);
      }

        break;
      case Sort :
        s_s_decision = get_char("B|I|Q|S");

        switch((BIQS)(toupper(s_s_decision))) {
          case BubbleSort : bubblesort_asc_int(given_list);
                            break;

          case InsertionSort : insertionsort_asc_int(given_list);
                               break;

          case QuickSort : quicksort_asc_int(given_list);
                           break;

          case SelectionSort : selectionsort_asc_int(given_list);
                               break;

          default : cerr << "Error: sort_decision should be B|I|Q|S" << endl;
                    exit(1);
        }

        put_list_int(given_list); 
        break;
      default : cerr << "Error: search_sort_decision should be S|O" << endl;
                exit(1);
    }

    repeat_decision = get_char("Yes/No");
  } while((YN)(toupper(repeat_decision))=='Y');

}
