/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   quicksort_asc_pqr.cpp
*/


#include "parameters.h"
#include "types.h"

int partition(pqr*, int, int);
void quicksort(pqr*, int, int);

void quicksort_asc_pqr(pqr *list) {
  int n = MAX_SIZE;
  quicksort(list,
            0,
            n-1);
}

int partition(pqr *list,
              int i,
              int j) {
  int middle = (i+j)/2;          // middle as the pivot

  pqr pivot = list[middle];
  list[middle] = list[i];
  list[i] = pivot;

  int p = i;

  pqr temp;

  for(int k=i+1; k<=j; ++k)
    if(list[k].p<pivot.p) {      // elements less than pivot
      ++p;                       // replaced by list[++p]
      temp.p = list[p].p;
      list[p].p = list[k].p;
      list[k].p = temp.p;
      temp.q = list[p].q;
      list[p].q = list[k].q;
      list[k].q = temp.q;
      temp.r = list[p].r;
      list[p].r = list[k].r;
      list[k].r = temp.r;
    }

  temp.p = list[i].p;            // pivot in list[p]
  list[i].p = list[p].p;
  list[p].p = temp.p;
  temp.q = list[i].q;
  list[i].q = list[p].q;
  list[p].q = temp.q;
  temp.r = list[i].r;
  list[i].r = list[p].r;
  list[p].r = temp.r;

  return p;                      // return pivot position
}

void quicksort(pqr *list,
               int i,
               int n) {
  int p;

  if(i<n) {
    p = partition(list,          // p is the list pivot position
                  i,
                  n);
    quicksort(list,
              i,
              p-1);
    quicksort(list,
              p+1,
              n);
  }
}
