/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   quicksort_asc_pqr.cpp
*/


#include "common.h"
#include "types.h"

int partition(vector<pqr>&, int, int);
void quicksort(vector<pqr>&, int, int);

void quicksort_asc_pqr(vector<pqr>& list) {
  int n = list.size();
  quicksort(list,
            0,
            n-1);
}

int partition(vector<pqr>& list,
              int i,
              int j) {
  int middle=(i+j)/2;            // middle as the pivot

  pqr pivot = list[middle];
  list[middle] = list[i];
  list[i] = pivot;

  int p = i;

  for(int k=i+1; k<=j; ++k)
    if(list[k].p<pivot.p) {      // elements less than pivot
      pqr temp = list[++p];      // replaced by list[++p]
      list[p] = list[k];
      list[k] = temp;
    }

  pqr temp = list[i];            // pivot in list[p]
  list[i] = list[p];
  list[p] = temp;

  return p;                      // return pivot position
}

void quicksort(vector<pqr>& list,
               int i,
               int n) {
  int p;

  if(i<n) {
    p = partition(list,          // p is the list pivot position
                  i,
                  n);
    quicksort(list,
              i,
              p-1);
    quicksort(list,
              p+1,
              n);
  }
}
