/*
   Copyright(C) 2004
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2004.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A() {
}

A::
A(const A& a) : data_a(a.data_a),
                data_b(a.data_b) {
}

A&
A::
operator=(const A& a) {
  if(this==&a) return *this;

  data_a = a.data_a;
  data_b = a.data_b;

  return *this;
}

int
A::
get_first_data_a() const {
  return data_a.front();
}

int
A::
get_last_data_a() const {
  return data_a.back();
}

int
A::
get_any_data_a(const int i) const {
  if(i<0 || i>data_a.size())
    throw out_of_range("index i is out_of_range");
  else 
    return data_a.at(i);
}

int
A::
get_first_data_b() const {
  return data_b.front();
}

int
A::
get_last_data_b() const {
  return data_b.back();
}

int
A::
get_any_data_b(const int i) const {
  if(i<0 || i>data_b.size())
    throw out_of_range("index i is out_of_range");
  else 
    return data_b.at(i);
}

void
A::
set_first_data_a(const int a) {
  if(data_a.empty())
    data_a.push_back(a);
  else
    data_a.at(0) = a;
}

void
A::
set_last_data_a(const int a) {
  if(data_a.empty())
    data_a.push_back(a);
  else
    data_a.at(data_a.size()-1) = a;
}

void
A::
set_all_data_a(const int a) {
  if(data_a.empty())
    data_a.push_back(a);
  else {
    int n = data_a.size();
    for(int i=0; i<n; i++)
      data_a.at(i) = a;
  }
}

void
A::
set_all_data_a(const vector<int>& a) {
  data_a = a;
}

void
A::
set_any_data_a(const int i,
               const int a) {
  if(i<0 || i>data_a.size())
    throw out_of_range("index i is out_of_range");
  else 
    data_a.at(i) = a;
}

void
A::
set_first_data_b(const int a) {
  if(data_b.empty())
    data_b.push_back(a);
  else
    data_b.at(0) = a;
}

void
A::
set_last_data_b(const int a) {
  if(data_b.empty())
    data_b.push_back(a);
  else
    data_b.at(data_b.size()-1) = a;
}

void
A::
set_all_data_b(const int a) {
  if(data_b.empty())
    data_b.push_back(a);
  else {
    int n = data_b.size();
    for(int i=0; i<n; i++)
      data_b.at(i) = a;
  }
}

void
A::
set_all_data_b(const vector<int>& a) {
  data_b = a;
}

void
A::
set_any_data_b(const int i,
               const int a) {
  if(i<0 || i>data_b.size())
    throw out_of_range("index i is out_of_range");
  else 
    data_b.at(i) = a;
}

A&
A::
operator+=(const A& a) {
  int n = data_a.size();
  int m = data_b.size();

  if(n!=data_a.size()||
     m!=data_b.size()) 
    throw out_of_range("mismatch sizes!");

  for(int i=0; i<n; i++)
    data_a.at(i) += a.data_a.at(i);

  for(int i=0; i<m; i++)
    data_b.at(i) += a.data_b.at(i);

  return *this;
}

A
operator+(const A& a,
          const A& b) {
  int n = a.data_a.size();
  int m = a.data_b.size();

  if(n!=b.data_a.size()||
     m!=b.data_b.size())
    throw out_of_range("mismatch sizes!");

  A c(a);

  for(int i=0; i<n; i++)
    c.data_a.at(i) = a.data_a.at(i) + b.data_a.at(i);

  for(int i=0; i<m; i++)
    c.data_b.at(i) = a.data_b.at(i) + b.data_b.at(i);

  return c;
}

ostream&
operator<<(ostream& os,
           const A& a) {
  os << endl;
  int n = a.data_a.size();
  for(int i=0; i<n; i++)
    os << a.data_a.at(i) << endl;
  os << endl;

  os << endl;
  n = a.data_b.size();
  for(int i=0; i<n; i++)
    os << a.data_b.at(i) << endl;
  os << endl;

  return os;
}
