/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.
 
   date   : September 1, 2005.
   author : Austin W. Westfall, Salih Yurttas.

   cubby_hole.cpp
*/


#ifndef CUBBY_HOLE_CPP
#define CUBBY_HOLE_CPP

#include "cubby_hole.h"

template<class T>
cubby_hole<T>::
cubby_hole(const int max_size) : max_size(max_size) {
}

template<class T>
cubby_hole<T>::
~cubby_hole() {
  mut.lock();
  while(data.size()>0)
    data.pop();
  mut.unlock();
}

template<class T>
int
cubby_hole<T>::
size() const {
  mut.lock();
  int result = data.size();
  mut.unlock();
  return result;
}

template<class T>
void
cubby_hole<T>::
put(T item) {
  mut.lock();
  data.push(item);
  mut.unlock();
}

template<class T>
T
cubby_hole<T>::
get() {
  mut.lock();
  T item = data.front();
  data.pop();
  mut.unlock();
  return item;
}
#endif
