/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.
 
   date   : September 1, 2005.
   author : Austin W. Westfall, Salih Yurttas.

   cubby_hole.h
*/


#include <queue>
#include <unistd.h>

#include "mutex.h"

using namespace std;

template<class T>
class cubby_hole {
public:
  cubby_hole(int max_size = 16);

  ~cubby_hole();

  int size() const;

  void put(T item);

  T get();

private:
  queue<T> data;
  mutex mut;
  int max_size;
};
