/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.
 
   date   : September 1, 2005.
   author : Austin W. Westfall, Salih Yurttas.

   producer.cpp
*/


#include <unistd.h>

#include "producer.h"

producer::
producer(cubby_hole<int>* c,
         const int pid) : ch(c),
                          id(pid),
                          num_items(0) {
}

void
producer::
produce(const int a) {
  num_items = a;
  start();
}

void
producer::
run() {
  for(int i=0; i<num_items; ++i) {
    ch->put(i);
    cout << "Producer #" << id << " put: " << i << endl;
    usleep(160);
  }
}
