/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A(const int a,
  const int b) {
  i0 = a;
  i1 = b;

  l = i0+i1;
  
  d = new int[l];
}

A::
A(const A& a) {
  i0 = a.i0;
  i1 = a.i1;

  l = a.l;
  d = new int[l];

  for(int i=0; i<l; i++)
    d[i] = a.d[i];
}

A::
~A() {
  delete [] d;
}

A&
A::
operator=(const A& a) {
  if(this==&a) return *this;

  delete [] d;

  i0 = a.i0;
  i1 = a.i1;

  l = a.l;
  d = new int[l];

  for(int i=0; i<l; i++)
    d[i] = a.d[i];

  return *this;
}

int
A::
get_l() const {
  return l;
}

int
A::
get_i0() const {
  return i0;
}

int
A::
get_i1() const {
  return i1;
}

void
A::
set_d(const int a) {
  for(int i=0; i<l; i++)
    d[i] = a;
}

ostream&
operator<<(ostream& os,
           const A& a) {
  os << endl;
  int n = a.l;

  for(int i=0; i<n; i++)
    os << a.d[i] << endl;
  os << endl;

  return os;
}
