/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   E.cpp
*/


#include "E.h"

E::
E(const int a,
  const int b) {
  s = a;
  d = new int[s];

  for(int i=0; i<s; i++)
    d[i]=b;
}

E::
E(const E& a) {
  s = a.s;
  d = new int[a.s];

  for(int i=0; i<s; i++)
    d[i]=a.d[i];
}

E&
E::
operator=(const E& a) {
  if(this==&a) return *this;

  delete [] d;

  s = a.s;
  d = new int[a.s];

  for(int i=0; i<s; i++)
    d[i]=a.d[i];

  return *this;
}

E::
~E() {
  delete [] d;
}

int
E::
get_s() const {
  return s;
}

int*
E::
get_d() const {
  return d;
}

void
E::
set_d(const int a) {
  for(int i=0; i<s; i++)
    d[i]=a;
}

void
E::
set_d(const int a,
      const int b) {
  d[a]=b; // assuming a is in valid range!
          // [ exception-handling is needed ]
}

void
E::
set_d(const int* a) {
  for(int i=0; i<s; i++) // assuming d and a has matching sizes
    d[i]=a[i];           // [ exception-handling is needed ]
}

ostream& operator<<(ostream& os,
                    const E& a) {
  for(int i=0; i<a.s; i++)
    os << a.d[i] << endl;

  os << endl;

  return os;
}
