/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A(const char a,
  const char b) : c1(a),
                  c2(b) {
}

A::
A(const A& o) : c1(o.c1),
                c2(o.c2) {
}

A&
A::
operator=(const A& o) {
  if(this==&o) return *this;

  c1 = o.c1;
  c2 = o.c2;

  return *this;
}

char
A::
get_c1() const {
  return c1;
}

char
A::
get_c2() const {
  return c2;
}

void
A::
set_c1(const char a) {
  c1 = a;
}

void
A::
set_c2(const char a) {
  c2 = a;
}

void
A::
set_c1_c2(const char a) {
  c1 = a;
  c2 = a;
}

void
A::
set_c1_c2(const char a,
          const char b) {
  c1 = a;
  c2 = b;
}

ostream&
operator<<(ostream& os,
           const A& o) {
  os << o.c1 << endl;
  os << o.c2 << endl;

  return os;
}
