/*
   Copyright(C) 2007
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.
 
   date   : January 1, 2007.
   author : Salih Yurttas.

   A.h
*/


#include <string>

using namespace std;

#include "A.h"

A::
A(const int s) : size(s),
                 a1(new int[size]) {
  if(size>0) 
    get_object(size);
}

void
A::
get_object(const int size) {
  string filename;

  cout << "-> input filename : ";
  cin >> filename;
  cout << endl;

  ifstream f_in(filename.c_str());

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }
  else {
    for(int i=0; i<size; ++i)
      f_in >> a1[i];

  }

  f_in.close();
}

A::
A(const A& o) : size(o.size),
                a1(new int[size]) {
  for(int i=0; i<size; ++i)
    a1[i] = o.a1[i];
}

A::
~A() {
  delete [] a1;
}

A&
A::
operator=(const A& o) {
  if(this==&o) return *this;

  delete [] a1;

  size = o.size;
  a1 = new int[size];

  for(int i=0; i<size; ++i)
    a1[i] = o.a1[i];

  return *this;
}

int
A::
get_size() const {
  return size;
}

int*
A::
get_a1() const {
  return a1;
}

void
A::
set_a1(const int a) {
  for(int i=0; i<size; ++i)
    a1[i] = a;
}

void
A::
set_a1(const int s,
       const int a) {
  delete [] a1;

  size = s;
  a1 = new int[size];

  for(int i=0; i<size; ++i)
    a1[i] = a;
}


void
A::
set_a1(const int s,
       const int* a) {
  delete [] a1;

  size = s;
  a1 = new int[size];

  for(int i=0; i<size; ++i)
    a1[i] = a[i];
}

ostream&
operator<<(ostream& os,
           const A& o) {
  for(int i=0; i<o.size; ++i)
    os << o.a1[i] << endl;
  os << endl;

  return os;
}
