/*
   Copyright(C) 2003
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2003.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A(const string a,
  const int b) {
  d_s.push_back(a);
  d_i.push_back(b);
}

A::
A(const A& a) : d_s(a.d_s),
                d_i(a.d_i) {
}

A&
A::
operator=(const A& a) {
  if(this==&a) return *this;

  d_s = a.d_s;
  d_i = a.d_i;

  return *this;
}

string
A::
get_d_s(const int a) const {
  return d_s[a];
}

vector<string>
A::
get_d_s(const int a,
        const int b) const {
  vector<string> t;
  for(int i=a; i<=b; i++)
    t.push_back(d_s[i]);
  return t;
}

vector<string>
A::
get_d_s() const {
  return d_s;
}

int
A::
get_d_i(const int a) const {
  return d_i[a];
}

vector<int>
A::
get_d_i(const int a,
        const int b) const {
  vector<int> t;
  for(int i=a; i<=b; i++)
    t.push_back(d_i[i]);
  return t;
}

vector<int>
A::
get_d_i() const {
  return d_i;
}

int
A::
get_d_s_size() const {
  return d_s.size();
}

int
A::
get_d_i_size() const {
  return d_i.size();
}

void
A::
set_d_s(const string& a) { 
  d_s.push_back(a);
}

void
A::
set_d_s(const int a,
        const string& b) { 
  d_s[a] = b;
}

void
A::
set_d_s(const vector<string>& a) { 
  int n = a.size();
  for(int i=0; i<n; i++)
    d_s.push_back(a.at(i));
}

void
A::
set_d_i(const int a) { 
  d_i.push_back(a);
}

void
A::
set_d_i(const int a,
        const int b) { 
  d_i[a] = b;
}

void
A::
set_d_i(const vector<int>& a) { 
  int n = a.size();
  for(int i=0; i<n; i++)
    d_i.push_back(a.at(i));
}

ostream&
operator<<(ostream& os,
           const A& a) {
  os << endl;
  int n = a.d_s.size();
  for(int i=0; i<n; i++)
    os << a.d_s.at(i) << endl;
  os << endl;

  n = a.d_i.size();
  for(int i=0; i<n; i++)
    os << a.d_i.at(i) << endl;
  os << endl;

  return os;
}
