/*
   Copyright(C) 2003
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2003.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A(const int a) {
  for(int i=0; i<a; i++)
    data.push_back(0);
}

A::
A(const A& a) : data(a.data) {
}

A&
A::
operator=(const A& a) {
  if(this==&a) return *this;

  data = a.data;

  return *this;
}

int
A::
get_first() const {
  return data.front();
}

int
A::
get_next_to_first() const {
  return data[1];
}

int
A::
get_last() const {
  return data.back();
}

int
A::
get_prior_to_last() const {
  return data[data.size()-2];
}

vector<int>
A::
get_all() const {
  return data;
}

int
A::
get_size() const {
  return data.size();
}

void
A::
set_first(const int a) {
  data[0] = a;
}

void
A::
set_next_to_first(const int a) {
  data[1] = a;
}

void
A::
set_prior_to_last(const int a) {
  data[data.size()-2] = a;
}

void
A::
set_last(const int a) {
  data[data.size()-1] = a;
}

void
A::
set_all(const int a) { 
  int n = data.size();
  for(int i=0; i<n; i++)
    data[i] = a;
}

void
A::
set_all(const vector<int>& a) { 
  int n = data.size();
  for(int i=0; i<n; i++)
    data[i] = a[i];
}

ostream&
operator<<(ostream& os,
           const A& a) {
  os << endl;
  int n = a.data.size();
  for(int i=0; i<n; i++)
    os << a.data.at(i) << endl;
  os << endl;

  return os;
}
