/*
   Copyright(C) 2007
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2007.
   author : Salih Yurttas.

   A.cpp
*/


#include <iostream>
#include <fstream>

using namespace std;

#include "A.h"

A::
A(const int s) : size(s),
                 a1(new int[size]) {
  if(size>0) get_list(size);
}


void
A::
get_list(const int size) {
  string filename;

  cout << "--> input filename : ";
  cin >> filename;
  cout << endl;

  ifstream f_in(filename.c_str());

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }
  else {
    for(int i=0; i<size; i++)
      f_in >> a1[i];
  }

  f_in.close();
}

A::
~A() {
  delete [] a1;
}

int
A::
get_size() const {
  return size;
}

int*
A::
get_a1() const {
  return a1;
}

void
A::
set_a1(const int a) {
  for(int i=0; i<size; i++)
    a1[i] = a;
}

ostream&
operator<<(ostream& os,
           const A& o) {
  int n = o.size;
  for(int i=0; i<n; i++)
    os << o.a1[i] << endl;
  os << endl;

  return os;
}
