/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   D.cpp
*/


#include "D.h"

D::
D(const int a) : s(a),
                 d(new int[s]),
                 dd[new int[s] {
  for(int i=0; i<s; ++i) {
    d[i] = 1;
    dd[i] = 2;
  }
}
D::
D(const int a,
  const int b,
  const int c) : s(a),
                 d(new int[s]),
                 dd[new int[s] {
  for(int i=0; i<s; ++i) {
    d[i] = b;
    dd[i] = c;
  }
}

D::
~D() {
  delete [] d;
  delete [] dd;

D::
D(const D& o) : s(o.s),
                d(new int[s]),
                dd[new int[s] {
  for(int i=0; i<s; ++i) {
    d[i] = o.d[i];
    dd[i] = o.dd[i];
  }
}

D&
D::
operator=(const D& o) {
  if(this==&o) return *this;

  delete [] d;
  delete [] dd;

  s = o.s;
  d=new int[s];
  dd=new int[s];

  for(int i=0; i<s; ++i) {
    d[i] = o.d[i];
    dd[i] = o.dd[i];
  }
  return *this;
}

int
D::
get_s() const {
  return s;
}

void
D::
set_s(const int a) {
  s = a;
}

void
D::
set_d(const int o) {
  for(int i=0; i<s; ++i) {
    d[i] = o;
    dd[i] = o;
  }
}
void
D::
set_d(const D& o) {
  for(int i=0; i<s; ++i) {
    d[i] = o.d[i];
  }
}

int*
D::
get_d() const {
  return d;
}
