/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   A.cpp
*/


#include "A.h"

A::
A(const char a,
  const char b) : c1_c2(new char[size]) {
  c1_c2[0] = a;
  c1_c2[1] = b;
}

A::
A(const A& o) : c1_c2(new char[size]) {
  c1_c2[0] = o.c1_c2[0];
  c1_c2[1] = o.c1_c2[1];
}

A&
A::
operator=(const A& o) {
  if(this==&o) return *this;

  delete [] c1_c2;

  c1_c2 = new char[size];

  c1_c2[0] = o.c1_c2[0];
  c1_c2[1] = o.c1_c2[1];

  return *this;
}

A::
~A() {
  delete [] c1_c2;
}

int
A::
get_length() const {
  return size;
}

char
A::
get_c1() const {
  return c1_c2[0];
}

void
A::
set_c1(const char a) {
  c1_c2[0] = a;
}

char
A::
get_c2() const {
  return c1_c2[0];
}

void
A::
set_c2(const char a) {
  c1_c2[1] = a;
}

void
A::
set_c1_c2(const char a) {
  c1_c2[0] = a;
  c1_c2[1] = a;
}

void
A::
set_c1_c2(const char a,
          const char b) {
  c1_c2[0] = a;
  c1_c2[1] = b;
}

ostream&
operator<<(ostream& os,
           const A& o) {
  os << o.c1_c2[0] << endl;
  os << o.c1_c2[1] << endl;

  return os;
}
