/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   S.cpp
*/


#include <cstring>

using namespace std;

#include "S.h"

S::
S(const char *a) {
  if(a) {
    l = strlen(a);
    s = new char[l+1];
    strcpy(s,a);
  }
  else {
    l = 0;
    s = new char[l+1];
    s = 0;
  }
}

S::
S(const S& a) {
  if(a.s) {
    l = strlen(a.s);
    s = new char[l+1];
    strcpy(s,a.s);
  }
  else {
    l = 0;
    s = new char[l+1];
    s = 0;
  }
}

S::
~S() {
  delete [] s;

  l = 0;
  s = 0;
}

S&
S::
operator=(const S& a) {
  if(this==&a) return *this;

  delete [] s;

  l = a.l;
  s = new char[l+1];

  strcpy(s,
         a.s);

  return *this;
}

S&
S::
operator=(const char* a) {
  if(*this==a) return *this;

  delete [] s;

  l = strlen(a);
  s = new char[l+1];

  strcpy(s,
         a);

  return *this;
}

S&
S::
operator+=(const S& a) {
  l += a.l;
  char *t = new char[l+1];

  strcpy(t,
         s);

  strcat(t,
         a.s);

  delete [] s;

  s = t;

  return *this;
}

int
S::
get_l() const {
  return l;
}

char*
S::
get_s() const {
  return s;
}

void
S::
set_s(const char* a) {
  delete [] s;

  l = strlen(a);
  s = new char[l+1];

  strcpy(s,
         a);
}

S
operator+(const S& a,
          const S& b) {
  int n = a.l + b.l;
  char *t = new char[n+1];

  strcpy(t,
         a.s);

  strcat(t,
         b.s);

  return t;
}

bool
operator==(const S& a,
           const S& b) {
  return (strcmp(a.s,
                 b.s)==0);
}


bool
operator!=(const S& a,
           const S& b) {
  return (strcmp(a.s,
                 b.s)!=0);
}

ostream&
operator<<(ostream& os,
           const S& a) {
  os << a.s << endl;

  return os;
}
