/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   V.cpp
*/


#include "V.h"

V::
V(const int n,
  const int v) : size(n),
                 data(new int[n]) {
  for(int i=0; i<size; i++)
    data[i] = v;
}

V::
V(const V& a) : size(a.size),
                data(new int[size]) {
  for(int i=0; i<size; i++)
    data[i] = a.data[i];
}

V::
~V() {
  delete [] data;
}

V&
V::
operator=(const V& a) {
  if(this==&a) return *this;

  delete [] data;

  size = a.size;
  data = new int[size];

  for(int i=0; i<size; i++)
    data[i] = a.data[i];

  return *this;
}

int
V::
get_size() const {
  return size;
}

int
V::
get_data(const int i) const {
  return data[i];             // assume i is within range
}

void
V::
set_data(const int* a) {
  for(int i=0; i<size; i++)   // assume has size matching size of data
    data[i] = a[i];
}

void
V::
set_data(const int a,
         const int i) {
  data[i] = a;                // assume i is within range
}

void
V::
set_data(const int* a,
         const int l) {
  delete [] data;

  size = l;
  data = new int[size];

  for(int i=0; i<size; i++)
    data[i] = a[i];
}

int&
V::
operator[](const int i) {
  return data[i];             // assume i is within range
}

V&
V::
operator+=(const V& a) {
  if(size!=a.size) {
    cerr << "not valid!" << endl;
    exit(1);
  }

  for(int i=0; i<a.size; i++)
    data[i] += a.data[i];

  return *this;
}

const
V
V::
operator+(const V& a) {
  if(size!=a.size) {
    cerr << "not valid!" << endl;
    exit(1);
  }

   V t = a;

  for(int i=0; i<a.size; i++)
    t.data[i] += a.data[i];

  return t;
}

bool
operator==(const V& a,
           const V& b) {
  if(a.size!=b.size)
    return false;

  for(int i=0; i<a.size; i++)
    if(a.data[i] != b.data[i]) return false;

  return true;
}

ostream&
operator<<(ostream& os,
           const V& a) {
  int n = a.size;

  for(int i=0; i<n; i++)
    os << a.data[i] << endl;
  os << endl;

  return os;
}
