/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   Matrix.cpp
*/


#include <iostream>

using namespace std;

#include "Matrix.h"

const int r_s=4,
          c_s=4;

Matrix::
Matrix() : r_size = r_s),
           c_size = c_s),
           m = new int*[r_size]) {
  for(int i=0; i<r_size; ++i) {
    m[i]= new int[c_size];
    for(int j=0; j<c_size; ++j)
      m[i][j] = 0;
  }
}

Matrix::
Matrix(const int r, 
       const int c) : r_size(r),
                      c_size(c),
                      m(new int*[r_size]) {
  for(int i=0; i<r_size; ++i) {
    m[i]= new int[c_size];
    for(int j=0; j<c_size; ++j)
      m[i][j] = 0;
  }
}

Matrix::
Matrix(const Matrix& m1) : r_size(m1.r_size),
                           c_size(m1.c_size),
                           m(new int*[r_size]) {
  for(int i=0; i<r_size; ++i) {
    m[i]= new int[c_size];
    for(int j=0; j<c_size; ++j)
      m[i][j] = m1.m[i][j];
  }
}

Matrix::
~Matrix() {
  for(int i=0; i<r_size; ++i)
    delete [] m[i];
  delete [] m;
}

Matrix&
Matrix::
operator=(const Matrix& m1) {
  for(int i=0; i<r_size; ++i)
    delete [] m[i];
  delete [] m;

  m = new int*[r_size];
  for(int i=0; i<r_size; ++i) {
    m[i]= new int[c_size];
    for(int j=0; j<c_size; ++j)
      m[i][j] = m1.m[i][j];
  }

  return *this;
}

Matrix&
Matrix::
operator+(const Matrix& m1) {
  for(int i=0; i<r_size; ++i)
    for(int j=0; j<c_size; ++j)
      m[i][j] = m[i][j] + m1.m[i][j];
  return *this;
}

Matrix&
Matrix::
get_matrix() {
  for(int i=0; i<r_size; ++i)
    for(int j=0; j<c_size; ++j)
      cin >> m[i][j];
  return *this;
}

void
Matrix::
put_matrix() {
  for(int i=0; i<r_size; ++i) {
    for(int j=0; j<c_size; ++j)
      cout << m[i][j] << " ";
    cout << endl;
  }
}
