/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   Matrix.h
*/


class Matrix {
public:
  Matrix(const int,
         const int);
  Matrix(const Matrix&);

  ~Matrix();

  Matrix& operator=(const Matrix&);

  Matrix& operator+=(const Matrix&);
  Matrix& operator-=(const Matrix&);
  Matrix& operator*=(const Matrix&);

  friend Matrix operator+(const Matrix&,
                          const Matrix&);
  friend Matrix operator-(const Matrix&,
                          const Matrix&);
  friend Matrix operator*(const Matrix&,
                          const Matrix&);

  friend Matrix operator*(const int,
                          const Matrix&);
  friend Matrix operator*(const Matrix&,
                          const int);

  int retrieve_element(const int,
                       const int) const;
  void assign_element(const int, 
                      const int,
                      const int);

  void negate();
 
  void put_matrix() const;

private:
  int r_size,
      c_size;
  int **m;
};
