/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   Complex.cpp
*/


#include "Complex.h"

Complex::
Complex(const double r,
        const double i) : re(r),
                          im(i) {
}

Complex::
Complex(const Complex& c) : re(c.re),
                            im(c.im) {
}

Complex::
~Complex() {
  delete re;
  delete im;
}

Complex&
Complex::
operator=(const Complex& a) {
  re = a.re;
  im = a.im;

  return *this;
}

Complex
operator+(const Complex& a,
          const Complex& b) {
  Complex t(a.re + b.re,
            a.im + b.im);

  return t;
}

ostream&
operator<<(ostream& os,
           const Complex& c) {
  os << c.re << endl;
  os << c.im << endl;

  return os;
}
