/*
   Copyright(C) 2000
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2000.
   author : Salih Yurttas [ modified from timoty budd example].

   rational.cpp
*/


#include "rational.h"

rational::
rational(const int n,
         const int d) : numerator(n),
                        denominator(d) {
}

rational::
rational(const rational& o) : numerator(o.numerator),
                              denominator(o.denominator) {
}

rational&
rational::
operator=(const rational& o) {
  numerator = o.numerator;
  denominator = o.denominator;

  return *this;
}

rational&
rational::
operator+=(const rational& o) {
  numerator = numerator * o.denominator +
              denominator * o.numerator;
  denominator *= o.denominator;

  return *this;
}

rational
operator+(const rational& o1,
          const rational& o2) {
  return rational(o1.numerator*o2.denominator+
                  o2.numerator*o1.denominator,
                  o1.denominator*o2.denominator);
}

ostream&
operator<<(ostream& os,
           const rational& r) {
  os << r.numerator << '/' << r.denominator << endl;

  return os;
}
