/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2001
   author : Salih Yurttas

   counter.cpp
*/


#include "counter.h"

counter::
counter(const int v,
        const int i,
        const int l) : data_value(v),
                       increment_value(i),
                       limit_value(l) {
}

counter::
counter(const counter& c) : data_value(c.data_value),
                            increment_value(c.increment_value),
                            limit_value(c.limit_value) {
}

counter&
counter::
operator=(const counter& c) {
  if(this==&c) return *this;

  data_value = c.data_value;
  increment_value = c.increment_value;
  limit_value = c.limit_value;

  return *this;
}

int
counter::
get_data_value() const {
  return data_value;
}

int
counter::
get_increment_value() const {
  return increment_value;
}

int
counter::
get_limit_value() const {
  return limit_value;
}

void
counter::
increment() {
  data_value = data_value+increment_value;

  if(data_value>limit_value)
    data_value = data_value-limit_value-increment_value;
}

void
counter::
decrement() {
  data_value = data_value-increment_value;

  if(data_value<0)
    data_value = data_value+limit_value+increment_value;
}

ostream&
operator<<(ostream& os,
           const counter& c) {
  os << "counter data_value      : " << c.data_value << endl;
  os << "counter increment_value : " << c.increment_value << endl;
  os << "counter limit_value     : " << c.limit_value << endl;

  return os;
}
