/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2001
   author : Salih Yurttas

   counter.h
*/


#ifndef COUNTER_H
#define COUNTER_H

#include <iostream>

using namespace std;

class counter {
public:
  counter(const int v=INITIAL,
          const int i=INCREMENT,
          const int l=LIMIT);

  counter(const counter&);

  counter& operator=(const counter&);

  int get_data_value() const;
  int get_increment_value() const;
  int get_limit_value() const;

  void increment();
  void decrement();

  friend ostream& operator<<(ostream&,
                             const counter&);

private:
  static const int INITIAL=0;
  static const int INCREMENT=1;
  static const int LIMIT=15;

  int data_value;
  int increment_value;
  int limit_value;
};
#endif
