/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2002.
   author : Salih Yurttas.

   Courses.cpp
*/

#include "Courses.h"

Courses::
Courses(const int a) : number_of_courses(a) {
}

Courses::
Courses(const Courses& a) {
  number_of_courses = a.number_of_courses;

  for(int i=0; i<number_of_courses; i++) {
    course_name.push_back(a.course_name[i]);
    
    grade.push_back(a.grade[i]);
  }
}

string
Courses::
get_course_name(const int a) const {
  return course_name[a];
}

char 
Courses::
get_course_grade(const int a) const {
  return grade[a];
}

int
Courses::
get_number_of_courses() const {
  return number_of_courses;
}

void
Courses::
set_course(const string& a) {
  string t = a;
  int length = t.length();

  while(length>1) {
    course_name.push_back(t.substr(1,7));
    grade.push_back(t.substr(9,1)[0]);
    number_of_courses++;
    t.erase(0,10);
    length = t.length();
  }
}

void
Courses::
set_course_name(const int a,
                const string& b) {
  course_name[a] = b;
}

void
Courses::
set_course_grade(const int a,
                 const char b) {
  grade[a] = b;
}

ostream&
operator<<(ostream& os,
           const Courses& a) {
  int n = a.number_of_courses;

  for(int i=0; i<n; i++) {
    os << ' ' << a.course_name[i];
    os << ' ' << a.grade[i];
  }
  os << endl;

  return os;
}
