/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2002.
   author : Salih Yurttas.

   Student.cpp
*/

#include "Student.h"

Student::
Student(const int a) {
  last_name="";
  m_i='\0';
  first_name="";

  number_of_courses = a;
}

Student::
Student(const Student& a) {
  last_name = a.Person::last_name;

  m_i = a.Person::m_i;

  first_name = a.Person::first_name;

  number_of_courses = a.Courses::number_of_courses;

  for(int i=0; i<number_of_courses; i++) {
    course_name.push_back(a.Courses::course_name[i]);
    grade.push_back(a.Courses::grade[i]);
  }
}

ostream&
operator<<(ostream& os,
           const Student& a) {
  string s_out;

  s_out += a.Person::last_name;
  s_out += " ";
  s_out += a.Person::m_i;
  s_out += " ";
  s_out += a.Person::first_name;
  s_out += " ";

  if(s_out.length()<16)
    s_out += "\t";

  os << s_out;

  if(s_out.length()<24)
    os << "\t";

  int n = a.Courses::number_of_courses;

  for(int i=0; i<n; i++) {
    os << ' ' << a.Courses::course_name[i];
    os << ' ' << a.Courses::grade[i];
  }
  os << endl;

  return os;
}
