/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2002.
   author : Salih Yurttas.

   students_process.cpp
*/


#include <iostream>
#include <fstream>
#include <iomanip>

#include <vector>
#include <string>

using namespace std;

#include "Person.h"
#include "Courses.h"
#include "Student.h"

#include "students_process.h"

const char GRADE='A';

vector<Student>
students_process::
get_list_students() {
  vector<Student> list;
  string filename;

  cout << endl;
  cout << "--> input filename : ";
  cin >> filename;

  ifstream f_in(filename.c_str());

  if(!f_in) {
    cerr << "File named as " << filename << " is not opened for input." << endl;
    exit(1);
  }

  else {
    string r;

    while(getline(f_in,r,'\n')) {
      string n = r.substr(0,25);
      r.erase(0,24);
      Student s(0);

      s.Person::set_name(n);
      s.Courses::set_course(r);

      int k = r.size();
      r.erase(k);

      list.push_back(s);
    }
  }

  f_in.close();

  return list;
}

vector<Student>
students_process::
extract_list_students_of_all_a(const vector<Student>& g_l) {
  vector<Student> e_l;

  int n = g_l.size();

  for(int i=0; i<n; i++) {
    int j;
    int m = g_l[i].get_number_of_courses();
    for(j=0; j<m; j++)
      if(g_l[i].get_course_grade(j)!=GRADE)
        break;

   if(j==m)
     e_l.push_back(g_l[i]);
  }

  return e_l;
}

vector<Student>
students_process::
extract_list_students_of_no_a(const vector<Student>& g_l) {
  vector<Student> e_l;

  int n = g_l.size();

  for(int i=0; i<n; i++) {
    int j;
    int m = g_l[i].get_number_of_courses();
    for(j=0; j<m; j++)
      if(g_l[i].get_course_grade(j)==GRADE)
        break;

   if(j==m)
     e_l.push_back(g_l[i]);
  }

  return e_l;
}

void
students_process::
put_list_students(const vector<Student>& list) {
  string filename;

  cout << endl;
  cout << "--> output filename : ";
  cin >> filename;

  ofstream f_out(filename.c_str());
  
  extern int course_index;

  int l_s = list.size();

  for(int i=0; i<l_s; i++)
    f_out << list[i];

  f_out.close();
}

char
students_process::
get_char(const string& s) {
  char value;

  cout << endl;
  cout << "Enter the ";
  cout << s;
  cout << " value in char : ";
  cin >> value;

  return value;
}
