/*
   Copyright(C) 2000
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2000.
   author : Salih Yurttas.

   V_R.cpp
*/


#include "V_R.h"

V_R::
V_R(const int n) : V(n) {
}

V_R::
V_R(const V_R& a) : V(a) {
}

V_R::
~V_R() {
  delete [] data;
}

V_R&
V_R::
operator=(const V_R& a) {
  if(this==&a) return *this;

  delete [] data;

  size = a.size;
  data = new int[size];

  for(int i=0; i<size; i++)
    data[i] = a.data[i];

  return *this;
}

int
V_R::
get_element(const int i) const {
  if(range_check(i))
    return data[i];
  else {
    cout << "error : index ";
    cout << i;
    cout << " is out of bounds.";
    cout << endl;
    return -INT_MAX;
  }
}

void
V_R::
set_element(const int i,
            const int v) {
  if(range_check(i))
    data[i] = v;
  else {
    cout << "error : index ";
    cout << i;
    cout << " is out of bounds.";
    cout << endl;
  }
}

bool
V_R::
range_check(const int i) const {
  return (i>=0 && i<size);
}

ostream& operator<<(ostream& os,
                    const V_R& a) {
  int n = a.size;

  for(int i=0; i<n; i++)
    os << a.data[i] << endl;
  os << endl;

  return os;
}
