/*
   Copyright (C) 2000
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2000.
   author : Salih Yurttas.

   V_S.h
*/


#include "V_S.h"

V_S::
V_S(const int n) : V(n) {
}

V_S::
V_S(const V_S& a) : V(a) {
}

V_S::
~V_S() {
  delete [] data;
}

V_S&
V_S::
operator=(const V_S& a) {
  if(this==&a) return *this;

  delete [] data;

  size = a.size;
  data = new int[size];

  for(int i=0; i<size; i++)
    data[i] = a.data[i];

  return *this;
}

void
V_S::
set_element(const int i,
            const int v) {
  data[i] = v;
  sort();
}

void
V_S::
add_element(const int v) {
  V::add_element(v);
  sort();
}

void
V_S::
sort() {
  for(int i=0; i<size-1; i++)
    for(int j=size-1; j>=i+1; j--)
      if(data[j]<data[j-1]) {
        int t = data[j];
        data[j] = data[j-1];
        data[j-1] = t;
      }
}

ostream& operator<<(ostream& os,
                    const V_S& a) {
  int n = a.size;

  for(int i=0; i<n; i++)
    os << a.data[i] << endl;
  os << endl;

  return os;
}
