/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   p_00.cpp
*/


#include <iostream>

using namespace std;

#include "P.h"

int main(int argc, char* argv[]) {

// static testing
  P p1;

  cout << "p1 initial values after default construction-P() /" << endl;
  p1.print();

  cout << endl;

  cout << "p1 accessors after mutators /" << endl;
  p1.set_i1(2);
  cout << p1.get_i1() << endl;
  cout << endl;

  P p2(9);

  cout << "p2 initial values after P(9) /" << endl;
  p2.print();

  cout << endl;

  P p3(p2);

  cout << "p3 initial values after copy construction p3(p2) /" << endl;
  p3.print();
  cout << "p2 values after copy construction p3(p2) /" << endl;
  p3.print();

  cout << endl;

  cout << "p3 accessors after mutators /" << endl;
  p3.set_i1(1);
  cout << p3.get_i1() << endl;
  cout << endl;

  cout << "p1 /" << endl;
  p1.print();
  cout << endl;
  cout << "p2 /" << endl;
  p2.print();
  cout << endl;

  p2 = p1;

  cout << "p2 values after p2=p1 /" << endl;
  p2.print();
  cout << endl;
  cout << "p1 values after p2=p1 /" << endl;
  p1.print();
  cout << endl;

// dynamic testing

  P * p4 = new P;

  cout << "p4 initial values after default construction-P() /" << endl;
  p4->print();
  cout << endl;

  cout << "p4 accessors after mutators /" << endl;
  p4->set_i1(2);
  cout << p4->get_i1() << endl;
  cout << endl;

  delete p4;

  p4 = new P(9);

  cout << "p4 initial values after P(9) /" << endl;
  p4->print();
  cout << endl;

  P * p5 = new P(*p4);

  cout << "p5 initial values after copy construction *p5(*p4) /" << endl;
  p5->print();
  cout << endl;
  cout << "p4 values after copy construction *p5(*p4) /" << endl;
  p4->print();
  cout << endl;

  cout << "p5 accessors after mutators /" << endl;
  p5->set_i1(1);
  cout << p5->get_i1() << endl;
  cout << endl;

  cout << "p4 /" << endl;
  p4->print();
  cout << endl;
  cout << "p5 /" << endl;
  p5->print();
  cout << endl;

  *p4 = *p5;

  cout << "p4 values after *p4=*p5 /" << endl;
  p4->print();
  cout << endl;
  cout << "p5 values after *p4=*p5 /" << endl;
  p5->print();
  cout << endl;
  
  P p6(*p4);

  cout << "p6 initial values after copy construction p6(*p4) /" << endl;
  p6.print();
  cout << endl;
  cout << "p4 values after copy construction p6(*p4) /" << endl;
  p4->print();
  cout << endl;

}
