/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2001.
   author : Salih Yurttas.

   Animal.cpp
*/

#include <cstring>

#include <iostream>

using namespace std;

#include "Animal.h"

Animal::  
Animal() {
  name = new char[1];
  *name = '\0';
  
  age = 0;
}

Animal::
Animal(const Animal& a) {
  name = new char[strlen(a.name)+1];
  strcpy(name,a.name);
  age = a.age;
}

Animal::
~Animal() {
  delete [] name;
}

Animal&
Animal::
operator=(const Animal& a) {
  if(this==&a) return *this;

  delete [] name;

  name = new char[strlen(a.name)+1];
  strcpy(name, a.name);

  age = a.age;

  return *this;
}

char* 
Animal::
get_name() const {
  return name;
}

int
Animal::
get_age() const {
  return age;
}

void 
Animal::
set_name(const char* s) {
  delete [] name;
  name = new char[strlen(s)+1];
  strcpy(name,s);
}

void 
Animal::
set_age(const int i) {
  age = i;
}

void
Animal::
print() const {
  cout << "Name: " << name << endl;
  cout << "Age: " << age << endl;
  cout << endl;
}
