/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2001.
   author : Salih Yurttas.

   Birds.cpp
*/


#include <cstring>

#include <iostream>

using namespace std;

#include "Birds.h"

Birds::
Birds() : Animal(),
          fly(true) {
}

Birds::
Birds(const Birds& a) : Animal(a),
                        fly(a.fly) {
}

Birds::
~Birds() {
}

Birds&
Birds::
operator=(const Birds& a) {
  if(this==&a) return *this;

  delete [] name;

  name = new char[strlen(a.name)+1];
  strcpy(name, a.name);

  age = a.age;

  fly = a.fly;

  return *this;
}

bool
Birds::
get_fly() const {
  return fly;
}

void
Birds::
set_fly(const bool a) {
  fly = a;
}

void
Birds::
print() const {
  cout << "Name: " << name << endl;
  cout << "Age: " << age << endl;
  cout << "Fly: " << fly << endl;
  cout << endl;
}
