/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2001.
   author : Salih Yurttas.

   Land.cpp
*/


#include <cstring>

#include <iostream>

using namespace std;

#include "Land.h"

Land::
Land() :  Mammals(),
          food('h') {
}

Land::
Land(const Land& a) : Mammals(a),
                      food(a.food) {
}

Land::
~Land() {
}

Land&
Land::
operator=(const Land& a) {
  if(this==&a) return *this;

  delete [] name;

  name = new char[strlen(a.name)+1];
  strcpy(name, a.name);

  age = a.age;
  legs = a.legs;

  food = a.food;

  return *this;
}

char
Land::
get_food() const {
  return food;
}

void
Land::
set_food(const char a) {
  food = a;
}

void
Land::
print() const {
  cout << "Name: " << name << endl;
  cout << "Age: " << age << endl;
  cout << "Legs: " << legs << endl;
  cout << "Food: " << food << endl;
  cout << endl;
}
