/*
   Copyright(C) 2001
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2001.
   author : Salih Yurttas.

   Mammals.cpp
*/


#include <cstring>

#include <iostream>

using namespace std;

#include "Mammals.h"

Mammals::
Mammals() : Animal(),
            legs(2) {
}

Mammals::
Mammals(const Mammals& a) : Animal(a),
                            legs(a.legs) {
}

Mammals::
~Mammals() {
}

Mammals&
Mammals::
operator=(const Mammals& a) {
  if(this==&a) return *this;

  delete [] name;

  name = new char[strlen(a.name)+1];
  strcpy(name, a.name);

  age = a.age;

  legs = a.legs;

  return *this;
}

int
Mammals::
get_legs() const {
  return legs;
}

void
Mammals::
set_legs(const int a) {
  legs = a;
}

void
Mammals::
print() const {
  cout << "Name: " << name << endl;
  cout << "Age: " << age << endl;
  cout << "Legs: " << legs << endl;
  cout << endl;
}
