/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2002.
   author : Salih Yurttas.

   vector_e.h
*/


#ifndef VECTOR_E_H
#define VECTOR_E_H

#include <iostream>

#include <vector>

using namespace std;

template <class T>
class vector_e : public vector<T> {
public:
  vector_e(const int,
           const T);

  vector_e(const vector_e<T>&);

  vector_e<T>& operator=(const vector_e<T>&);

  T& operator[](const int);

  int get_size() const;

  T get_element(const int) const;

  vector<T> get_element(const int,
                        const int) const;

  void set_element(const int,
                   const T);

  friend ostream& operator<< <T>(ostream&,
                                 const vector_e<T>&);

private:
  vector<T> d;
};
#endif
