/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : June 1, 2002.
   author : Salih Yurttas.

   vector_e.cpp
*/


#include "vector_e.h"

template <class T>
vector_e<T>::
vector_e(const int a,
         const T b) : d(a,b) {
}

template <class T>
vector_e<T>::
vector_e<T>(const vector_e<T>& a) {
  int n = a.d.size();
  for(int i=0; i<n; i++)
    d.push_back(a.d[i]);
}

template <class T>
vector_e<T>&
vector_e<T>::
operator=(const vector_e<T>& a) {
  if(this==&a) return *this;

  d.clear();

  int n = a.d.size();
  for(int i=0; i<n; i++)
    d.push_back(a.d[i]);

  return *this;
}

template <class T>
int
vector_e<T>::
get_size() const {
  return d.size();
}

template <class T>
T
vector_e<T>::
get_element(const int a) const {
  if(a>=0&&a<d.size())
    return d[a];
  else     
    cerr << "Beyond scope" << endl;
}

template <class T>
vector<T>
vector_e<T>::
get_element(const int a,
            const int b) const {
  vector<T> t;

  if((a>=0&&a<d.size()) &&
     (b>=0&&b<d.size()))
    for(int i=a; i<=b; i++)
      t.push_back(d[i]);

  return t;
}

template <class T>
void
vector_e<T>::
set_element(const int a,
            const T b) {
  if(a>=0&&a<d.size())
    d[a]=b;
  else 
    cerr << "Beyond scope" << endl;
}

template <class T>
T&
vector_e<T>::
operator[](const int a) {
  if(a>=0&&a<d.size())
    return d[a];
}

template <class T>
ostream&
operator<<(ostream& os,
           const vector_e<T>& a) {
  int n = a.d.size();

  for(int i=0; i<n; i++)
    os << a.d[i] << endl;
  os << endl;

  return os;
}
