/*
   Copyright(C) 2007
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : December 1, 2007.
   author : Salih Yurttas.

   A.h
*/


#ifndef A_H
#define A_H

#include <iostream>

using namespace std;

template<class T>
class A {
public:
  A(const T v=0);             // default values are problematical.

  A(const A<T>&);

  A<T>& operator=(const A<T>&);

  T get_a0() const;

  void set_a0(const T);

  A<T>& operator+=(const A<T>&);
  A<T>& operator-=(const A<T>&);
  A<T>& operator*=(const A<T>&);
  A<T>& operator/=(const A<T>&);

  template<class U>           // this syntax changed several times
  friend A<U> operator+(const A<U>&,
                        const A<U>&);

  template<class U>           // this syntax changed several times
  friend A<U> operator-(const A<U>&,
                        const A<U>&);

  template<class U>           // this syntax changed several times
  friend A<U> operator*(const A<U>&,
                        const A<U>&);

  template<class U>           // this syntax changed several times
  friend A<U> operator/(const A<U>&,
                        const A<U>&);

  template<class U>           // this syntax changed several times
  friend ostream& operator<<(ostream&,
                             const A<U>&);

private:
  T a0;
};
#endif
