/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   I_A.cpp
*/


#include "I_A.h"

I_A::
I_A() : s(0),
        d(NULL) {
}

I_A::
I_A(const I_A& o) : s(o.s),
                    d(new int[s]) {
  for(int i=0; i<s; ++i)
    d[i] = o.d[i];
}

I_A&
I_A::
operator=(const I_A& o) {
  if(this==&o) return *this;

  delete [] d;

  s = o.s;
  d = new int[s];

  for(int i=0; i<s; ++i)
    d[i] = o.d[i];

  return *this;
}

I_A::
~I_A() {
  delete [] d;
  d = NULL;
  s = 0;
}

int
I_A::
get_s() const {
  return s;
}

int
I_A::
get_d(const int index) const { // assuming index in in valid range
  return d[index];             // [ exception-handling is needed ]
}

int*
I_A::
get_d() const {
  return d;
}

void
I_A::
set_d(const int size,
      const int value) {
  delete [] d;

  s = size;
  d = new int[s];

  for(int i=0; i<s; ++i)
    d[i] = value;
}

ostream&
operator<<(ostream& os,
           const I_A& o) {
  for(int i=0; i<o.s; ++i)
    os << o.d[i] << endl;

  return os;
}
