/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   D_A.cpp
*/


#include "D_A.h"

D_A::
D_A() : s(0),
        d(NULL) {
}

D_A::
D_A(const D_A& o) : s(o.s),
                    d(new double[s]) {
  for(int i=0; i<s; ++i)
    d[i] = o.d[i];
}

D_A&
D_A::
operator=(const D_A& o) {
  if(this==&o) return *this;

  delete [] d;

  s = o.s;
  d = new double[s];

  for(int i=0; i<s; ++i)
    d[i] = o.d[i];

  return *this;
}

D_A::
~D_A() {
  delete [] d;
  d = NULL;
  s = 0;
}

int
D_A::
get_s() const {
  return s;
}

double
D_A::
get_d(const int index) const { // assuming index in in valid range
  return d[index];             // [ exception-handling is needed ]
}

double*
D_A::
get_d() const {
  return d;
}

void
D_A::
set_d(const int size,
      const double value) {
  delete [] d;

  s = size;
  d = new double[s];

  for(int i=0; i<s; ++i)
    d[i] = value;
}

ostream&
operator<<(ostream& os,
           const D_A& o) {
  for(int i=0; i<o.s; ++i)
    os << o.d[i] << endl;

  return os;
}
