/*
   Copyright(C) 2007
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : December 1, 2007.
   author : Salih Yurttas.

   T_A.cpp
*/


#include "T_A.h"

template<class T>
T_A<T>::
T_A() : s(0),
        d(NULL) {
}

template<class T>
T_A<T>::
T_A(const T_A<T>& o) : s(o.s),
                       d(new T[s]) {
  for(int i=0; i<s; ++i)
    d[i] = o.d[i];
}

template<class T>
T_A<T>&
T_A<T>::
operator=(const T_A<T>& o) {
  if(this==&o) return *this;

  delete [] d;

  s = o.s;
  d = new T[s];

  for(int i=0; i<s; ++i)
    d[i] = o.d[i];

  return *this;
}

template<class T>
T_A<T>::
~T_A() {
  delete [] d;
  d = NULL;
  s = 0;
}

template<class T>
int
T_A<T>::
get_s() const {
  return s;
}

template<class T>
T
T_A<T>::
get_d(const int index) const { // assuming index in in valid range
  return d[index];             // [ exception-handling is needed ]
}

template<class T>
T*
T_A<T>::
get_d() const {
  return d;
}

template<class T>
void
T_A<T>::
set_d(const int size,
      const T value) {
  delete [] d;

  s = size;
  d = new T[s];

  for(int i=0; i<s; ++i)
    d[i] = value;
}

template<class T>
ostream&
operator<<(ostream& os,
           const T_A<T>& o) {
  for(int i=0; i<o.s; ++i)
    os << o.d[i] << endl;

  return os;
}
