/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   I_D_A.cpp
*/


#include "I_D_A.h"

I_D_A::
I_D_A() : s(0),
          i_a(NULL),
          d_a(NULL) {
}

I_D_A::
I_D_A(const I_D_A& o) : s(o.s),
                        i_a(new int[s]),
                        d_a(new double[s]) {
  for(int i=0; i<s; ++i) {
    i_a[i] = o.i_a[i];
    d_a[i] = o.d_a[i];
  }
}

I_D_A&
I_D_A::
operator=(const I_D_A& o) {
  if(this==&o) return *this;

  delete [] i_a;
  delete [] d_a;

  s = o.s;
  i_a = new int[s];
  d_a = new double[s];

  for(int i=0; i<s; ++i) {
    i_a[i] = o.i_a[i];
    d_a[i] = o.d_a[i];
  }

  return *this;
}

I_D_A::
~I_D_A() {
  delete [] i_a;
  delete [] d_a;
  i_a = NULL;
  d_a = NULL;
  s = 0;
}

int
I_D_A::
get_s() const {
  return s;
}

int
I_D_A::
get_i_a(const int index) const { // assuming index in in valid range
  return i_a[index];             // [ exception-handling is needed ]
}

int*
I_D_A::
get_i_a() const {
  return i_a;
}

void
I_D_A::
set_i_a(const int i_value) {
  for(int i=0; i<s; ++i)
    i_a[i] = i_value;
}

double
I_D_A::
get_d_a(const int index) const { // assuming index in in valid range
  return d_a[index];             // [ exception-handling is needed ]
}

double*
I_D_A::
get_d_a() const {
  return d_a;
}

void
I_D_A::
set_d_a(const double d_value) {
  for(int i=0; i<s; ++i)
    d_a[i] = d_value;
}

void
I_D_A::
set_i_d(const int size,
        const int i_value,
        const double d_value) {
  delete [] i_a;
  delete [] d_a;

  s = size;
  i_a = new int[s];
  d_a = new double[s];

  for(int i=0; i<s; ++i) {
    i_a[i] = i_value;
    d_a[i] = d_value;
  }
}

ostream&
operator<<(ostream& os,
           const I_D_A& o) {
  for(int i=0; i<o.s; ++i)
    os << o.i_a[i] << endl;

  for(int i=0; i<o.s; ++i)
    os << o.d_a[i] << endl;

  return os;
}
