/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   T_A.cpp
*/


#include "T_A.h"

template<class T0,
         class T1>
T_A<T0,T1>::
T_A() : s(0),
        d0(NULL),
        d1(NULL) {
}

template<class T0,
         class T1>
T_A<T0,T1>::
T_A(const T_A& o) : s(o.s),
                    d0(new T0[s]),
                    d1(new T1[s]) {
  for(int i=0; i<s; ++i) {
    d0[i] = o.d0[i];
    d1[i] = o.d1[i];
  }
}

template<class T0,
         class T1>
T_A<T0,T1>&
T_A<T0,T1>::
operator=(const T_A<T0,T1>& o) {
  if(this==&o) return *this;

  delete [] d0;
  delete [] d1;

  s = o.s;
  d0 = new T0[s];
  d1 = new T1[s];

  for(int i=0; i<s; ++i) {
    d0[i] = o.d0[i];
    d1[i] = o.d1[i];
  }

  return *this;
}

template<class T0,
         class T1>
T_A<T0,T1>::
~T_A() {
  delete [] d0;
  delete [] d1;
  d0 = NULL;
  d1 = NULL;
  s = 0;
}

template<class T0,
         class T1>
int
T_A<T0,T1>::
get_s() const {
  return s;
}

template<class T0,
         class T1>
T0
T_A<T0,T1>::
get_d0(const int index) const { // assuming index in in valid range
  return d0[index];             // [ exception-handling is needed ]
}

template<class T0,
         class T1>
T0*
T_A<T0,T1>::
get_d0() const {
  return d0;
}

template<class T0,
         class T1>
void
T_A<T0,T1>::
set_d0(const T0 value) {
  for(int i=0; i<s; ++i)
    d0[i] = value;
}

template<class T0,
         class T1>
T1
T_A<T0,T1>::
get_d1(const int index) const { // assuming index in in valid range
  return d1[index];             // [ exception-handling is needed ]
}

template<class T0,
         class T1>
T1*
T_A<T0,T1>::
get_d1() const {
  return d1;
}

template<class T0,
         class T1>
void
T_A<T0,T1>::
set_d1(const T1 value) {
  for(int i=0; i<s; ++i)
    d1[i] = value;
}

template<class T0,
         class T1>
void
T_A<T0,T1>::
set_d0_d1(const int size,
          const T0 t0_value,
          const T1 t1_value) {
  delete [] d0;
  delete [] d1;

  s = size;
  d0 = new T0[s];
  d1 = new T1[s];

  for(int i=0; i<s; ++i) {
    d0[i] = t0_value;
    d1[i] = t1_value;
  }
}

template<class T0,
         class T1>
ostream&
operator<<(ostream& os,
           const T_A<T0,T1>& o) {
  for(int i=0; i<o.s; ++i)
    os << o.d0[i] << endl;

  for(int i=0; i<o.s; ++i)
    os << o.d1[i] << endl;

  return os;
}
