/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   T_A.cpp
*/


#include "T_A.h"

template<class T>
T_A<T>::
T_A() : s(0),
        d(NULL) {
}

template<class T>
T_A<T>::
T_A(const T_A<T>& o) : s(o.s),
                       d(new T[s]) {
  for(int i=0; i<s; i++)
    d[i] = o.d[i];
}

template<class T>
T_A<T>&
T_A<T>::
operator=(const T_A& o) {
  if(this==&o) return *this;

  delete [] d;

  s = o.s;
  d = new T[s];

  for(int i=0; i<s; i++)
    d[i] = o.d[i];

  return *this;
}

template<class T>
T_A<T>::
~T_A() {
  delete [] d;
}

template<class T>
int
T_A<T>::
get_s() const {
  return s;
}

template<class T>
T
T_A<T>::
get_d(const int index) const { // assuming index in in valid range
  return d[index];             // [ exception-handling is needed ]
}

template<class T>
T*
T_A<T>::
get_d() const {
  return d;
}

template<class T>
void
T_A<T>::
set_d(const int size) {
  delete [] d;

  s = size;
  d = new T[s];

  for(int i=0; i<s; i++)
    d[i] = 0;
}

template<class T>
void
T_A<T>::
set_d(const int index,
      const T value) { // assuming index is in valid range
  d[index] = value;    // [ exception-handling is needed ]
}

template<class T>
ostream&
operator<<(ostream& os,
           const T_A<T>& o) {
  for(int i=0; i<o.s; i++)
    os << o.d[i] << endl;

  return os;
}
