/*
   Copyright(C) 2002
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 2002.
   author : Salih Yurttas.

   sort.cpp
*/


#include "sort.h"

using namespace std;

template <class T>
void sort(vector<T>& list) {
  get_vector_item(list);

  char sort_order_decision = get_char("A|D");

  char sort_decision = get_char("B|I|Q|S");

  switch((AD)(toupper(sort_order_decision))) {
    case Ascending : {
      switch((BIQS)(toupper(sort_decision))) {
        case BubbleSort : bubblesort(list,
                                     less<T>());
                          break;
        case InsertionSort : insertionsort(list,
                                           less<T>());
                             break;
        case QuickSort : quicksort(list,
                                   less<T>());
                         break;
        case SelectionSort : selectionsort(list,
                                           less<T>());
                             break;
        default : cerr << "Error: sort_decision should be B|I|Q|S" << endl;
                  exit(1);
      }
    }
    break;

    case Descending : {
      switch((BIQS)(toupper(sort_decision))) {
        case BubbleSort : bubblesort(list,
                                     greater<T>());
                          break;
        case InsertionSort : insertionsort(list,
                                           greater<T>());
                             break;
        case QuickSort : quicksort(list,
                                   greater<T>());
                         break;
        case SelectionSort : selectionsort(list,
                                           greater<T>());
                             break;
        default : cerr << "Error: sort_decision should be B|I|Q|S" << endl;
                  exit(1);
      }
    }
  }

  put_vector_item(list);
}
