/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   io_99.cpp
*/


#include <iostream>

#include <fstream>

using namespace std;

void double_space(ifstream& i_f,
                  ofstream& o_f) {
  char c;

  while(i_f.get(c)) {
    o_f.put(c);
    if(c=='\n') 
      o_f.put(c);
  }
}


int main(int argc, char* argv[]) {

  if(argc != 3 ) {
    cout << "\nUsage: " << argv[0]
         << " infile outfile\n";
    exit(1);
  }

  ifstream f_in;
  ofstream f_out;

  f_in.open(argv[1], ios::in);
  f_out.open(argv[2], ios::out);

  if(!f_in) {
    cerr << "cannot open " << argv[1];
    exit(1);
  }

  if(!f_out) {
    cerr << "cannot open " << argv[2];
    exit(1);
  }

  double_space(f_in,
               f_out);

  f_in.close();
  f_out.close();

}
