/*
   Copyright(C) 1998
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : January 1, 1998.
   author : Salih Yurttas.

   io_gs_02.cpp
*/


#include <iostream>

#include <fstream>

#include <cstring>

using namespace std;

const int MAX_NO_STRING=16;
const int MAX_SIZE_STRING=64;

void double_space(ifstream& i_f,
                  ofstream& o_f) {
  char *s[MAX_NO_STRING];

  int i=0;
  s[i] = new char[MAX_SIZE_STRING];
  while(i_f.getline(s[i], MAX_SIZE_STRING)) {
    s[++i] = new char[MAX_SIZE_STRING];
  }

  for(int j=0; j<i; j++)
    o_f << s[j] << endl << endl;
}


int main(int argc, char* argv[]) {

  if(argc!=3) {
    cout << "\nUsage: " << argv[0]
         << " infile outfile\n";
    exit(1);
  }

  ifstream f_in(argv[1]);
  ofstream f_out(argv[2]);

  if(!f_in) {
    cerr << "cannot open " << argv[1];
    exit(1);
  }

  if(!f_out) {
    cerr << "cannot open " << argv[2];
    exit(1);
  }

  double_space(f_in,
               f_out);

}
