/*
   Copyright(C) 2003
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2003.
   author : Salih Yurttas.

   purpose : integration of f(x).

   integrate.cpp
*/


template<class F>
double
integrate(const double a,
          const double b,
          const F& fx) {
// evaluates approximately the integral of f(x)
// between limits a and b,
// using the trapezoidal rule with 8 intervals

  int n = 8;

  double w = (b-a) / (double) n;

  double sum = (fx(a) + fx(b)) / 2.0;

  for(int i=1; i<n; i++)
    sum += fx((a + (double) i * w));

  return w*sum;
}
