// k1/a4/slist : list template for singly-linked lists
//  T is a placeholder for the data type of a list element.
// INCOMPLETE!!!!!! (only functions needed for the example are implemented)
#ifndef SIMPLELIST_H
#define SIMPLELIST_H SIMPLELIST_H

#include<cassert>

template<class T>
class slist
{
  public:
    slist() : firstElement(0), Count(0) {}

    /* copy constructor, destructor and assignment operator are
       omitted! The implementation of push_front() creates a new list
       element and inserts it at the beginning of the list: */

    void push_front(const T& Datum) // insert at beginning
    {
      firstElement =  new ListElement(Datum, firstElement);
      ++Count;
    }

  private:
    struct ListElement
    {
        T Data;
        ListElement *Next;
        ListElement(const T& Datum, ListElement* p)
        : Data(Datum), Next(p) {}
    };

    ListElement *firstElement;
    size_t Count;

    /* The list consists of list elements whose type is defined inside
       the list class as a nested public class (struct). In a
       structure, direct access to internal data is possible, but this
       is no problem here because the data is located in the private
       section of the slist class. Each list element carries the
       pertinent data, for example a number, together with a pointer
       to the next list element. firstElement is the pointer to the
       first list element. The class slist provides an iterator type
       iterator which is located in the public section since it is to
       be publicly accessible. It is also used in the following main()
       program. An iterator object stores the current container
       position in the current attribute. The methods satisfy the
       requirements formulated for iterators. */

  public:
    class iterator
    {
       public:
        // some types to satisfy the pedantic GNU 2.95.2
        typedef forward_iterator_tag iterator_category;
        typedef T value_type;
        typedef T* pointer;
        typedef T& reference;
        typedef size_t size_type;
        typedef ptrdiff_t difference_type;

         iterator(ListElement* Init = 0)
         : current(Init){}

         T& operator*()              // dereferencing
         {
             return current->Data;
         }

         const T& operator*() const  // dereferencing
         {
             return current->Data;
         }

         iterator& operator++()       // prefix
         {
            if(current) // not yet arrived at the end?
               current = current->Next;
            return *this;
         }

         iterator operator++(int)   // postfix
         {
            iterator temp = *this;
            ++*this;
            return temp;
         }

         bool operator==(const iterator& x) const
         {
            return current == x.current;
         }

         bool operator!=(const iterator& x) const
         {
            return current != x.current;
         }

         int operator-(iterator fromWhere)
         {
            int Count = 0;
            while(fromWhere.current != current // not yet reached
                && fromWhere.current != 0)    // not yet at the end
           {
              ++Count;
              ++fromWhere;
           }
           assert(current == fromWhere.current);
           return Count;
         }
       private:        
         ListElement* current; // pointer to current element 
    }; // iterator

    iterator begin() const { return iterator(firstElement);}
    iterator end()   const { return iterator();}

    /* Some types of the iterator get public names. Then it is
       possible to use them outside the class without knowing the
       implementation. */

    typedef T value_type;
    typedef ptrdiff_t difference_type;
    typedef T* pointer;
    typedef T& reference;
    // etc. see text
};
#endif //  SIMPLELIST_H

