/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2005.
   author : Salih Yurttas.

   print_dna_counts_list.cpp
*/


#include "common.h"
#include "io.h"

string get_string(string);

void print_dna_counts_list(const string& filename,
                           const multimap< string, int, less<string> >& dna_counts) {
  string out_name = get_string("output filename : ");

  ofstream f_out(out_name.c_str());
  
  f_out << filename;
  f_out << " -";
  f_out << endl;

  multimap<string, int, less<string> >::const_iterator i = dna_counts.begin();
  multimap<string, int, less<string> >::const_iterator k = dna_counts.end();

  for(; i!=k; ++i) {
    f_out.fill(' ');
    f_out.width(2);
    f_out.setf(ios::right);

    f_out << i->first << " - " << i->second << endl;
  }
  f_out << endl;

  f_out.close();
}
