/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2005.
   author : Salih Yurttas.

   dna_counts_01.cpp
*/


#include "parameters.h"
#include "f_specs.h"

int main(int argc, char* argv[]) {

  do {
    string filename = get_string("dna filenames : ");

    vector<string> filenames = get_data(filename);

    vector< multimap< string, int, less<string> > > dna_counts_list;

    int n = filenames.size();
    for(int i=0; i<n; ++i) {
      string filename = filenames.at(i);

      vector<string> given = get_data(filename);

      given = to_upper_sequence(given);

      vector<int> counts = count(given);

      multimap< string, int, less<string> > dna_counts = construct_map(given,
                                                                       counts);

      dna_counts_list.push_back(dna_counts);
    }

    print_dna_counts_list(filenames,
                          dna_counts_list);
  }
  while((YN)(toupper(get_char("Yes|No")))=='Y');

}
