/*
   Copyright(C) 2005
   All Rights Reserved. Salih Yurttas, Computer Science, TAMU.

   Permission to use, copy, modify, and distribute this
   software and its documentation for EDUCATIONAL purposes
   and without fee is hereby granted provided that this
   copyright notice appears in all copies.

   date   : September 1, 2005.
   author : Salih Yurttas.

   print_dna_counts_list.cpp
*/


#include "common.h"
#include "io.h"

string get_string(string);

void print_dna_counts_list(const vector<string>& filenames,
                           const vector< multimap< string, int, less<string> > >& dna_counts_list) {
  string filename = get_string("output filename : ");

  ofstream f_out(filename.c_str());
  
  int n = filenames.size();

  for(int i=0; i<n; ++i) {
    f_out << filenames.at(i);
    f_out << " -";
    f_out << endl;

    multimap< string, int, less<string> > dna_counts = dna_counts_list.at(i);

    multimap<string, int, less<string> >::const_iterator j = dna_counts.begin();
    multimap<string, int, less<string> >::const_iterator k = dna_counts.end();

    for(; j!=k; ++j) {
      f_out.fill(' ');
      f_out.width(2);
      f_out.setf(ios::right);

      f_out << j->first << " - " << j->second << endl;
    }
    f_out << endl;
  }

  f_out.close();
}
